
--misc
local wm = GetWindowManager()
local xbb = ZO_Object:Subclass()
local em = GetEventManager()

----------------------------------------------------------------------- 

function xbb:New()
	
		xbb.AddOnName = "XpBarBubble"
		--filepath
		xbb.FullBubblePve = xbb.AddOnName .. "/media/full_pve.dds"
		xbb.FullBubblePvp = xbb.AddOnName .. "/media/full_pvp.dds"
		xbb.EmptyBubblePve = xbb.AddOnName .. "/media/empty_pve.dds"
		xbb.EmptyBubblePvp = xbb.AddOnName .. "/media/empty_pvp.dds"
		--windows
		xbb.MW = nil
		xbb.OW = nil
		xbb.flat_x, xbb.flat_y = 0, 0
		xbb.bar_offset_x_pve, xbb.bar_offset_x_pvp, xbb.bar_offset_y_pve, xbb.bar_offset_y_pvp = 0, 0, 0, 0
	
		--pve
		xbb.PlayerXP_pve, xbb.PlayerXPtoLevel_pve, xbb.PlayerLevel_pve = 0, 0, 0
		xbb.numberOfFull_pve, xbb.BubbleXP_pve, xbb.BubbleXPCurrent_pve, xbb.XpBarPercent_pve = 0, 0 ,0 ,0
		
		--pvp
		xbb.PlayerXP_pvp, xbb.PlayerXPtoLevel_pvp, xbb.PlayerLevel_pve, xbb.PlayerTotalXP_pve = 0, 0, 0, 0
		xbb.numberOfFull_pvp, xbb.BubbleXP_pvp, xbb.BubbleXPCurrent_pvp, xbb.XpBarPercent_pvp = 0, 0 ,0 ,0
		xbb:AddOnEventManager()
 end

-----------------------------------------------------------------------	
	
function xbb:AddOnEventManager()
	em:RegisterForEvent(xbb.AddOnName .. "_AddOnLoaded", EVENT_ADD_ON_LOADED, function(...) self:OnAddOnLoaded(...) end)
	em:RegisterForEvent(xbb.AddOnName .. "_ExperienceUpdate", EVENT_EXPERIENCE_UPDATE , function() self:UpdatePve() end)
	em:RegisterForEvent(xbb.AddOnName .. "_VeteranPointsUpdate", EVENT_VETERAN_POINTS_UPDATE , function() self:UpdatePve() end)
	em:RegisterForEvent(xbb.AddOnName .. "_RankPointUpdate", EVENT_RANK_POINT_UPDATE , function() self:UpdatePvp() end)
	em:RegisterForEvent(xbb.AddOnName .. "_ReticleHiddenUpdate", EVENT_RETICLE_HIDDEN_UPDATE, function() self:MenuOpened() end) 
end 

-----------------------------------------------------------------------

function xbb:UpdateDataPve ()
	--pve
	xbb.PlayerLevel_pve = GetUnitLevel("player") + 1
	if (xbb.PlayerLevel_pve == 51) then
	
		xbb.PlayerXP_pve = GetUnitVeteranPoints("player")	
		xbb.PlayerXPtoLevel_pve = GetUnitVeteranPointsMax('player')
		xbb.numberOfFull_pve = math.floor ((xbb.PlayerXP_pve / xbb.PlayerXPtoLevel_pve) * 10)
		xbb.BubbleXP_pve = xbb.PlayerXPtoLevel_pve / 10
		xbb.BubbleXPCurrent_pve = xbb.PlayerXP_pve - (xbb.BubbleXP_pve * xbb.numberOfFull_pve)
		xbb.XpBarPercent_pve = math.floor ((xbb.BubbleXPCurrent_pve / xbb.BubbleXP_pve) * 100)
		xbb.PlayerLevel_pve = "VL" .. GetUnitVeteranRank("player")
	else
		xbb.PlayerXP_pve = GetUnitXP("player")	
		xbb.PlayerXPtoLevel_pve = GetUnitXPMax('player')
		xbb.numberOfFull_pve = math.floor ((xbb.PlayerXP_pve / xbb.PlayerXPtoLevel_pve) * 10)
		xbb.BubbleXP_pve = xbb.PlayerXPtoLevel_pve / 10
		xbb.BubbleXPCurrent_pve = xbb.PlayerXP_pve - (xbb.BubbleXP_pve * xbb.numberOfFull_pve)
		xbb.XpBarPercent_pve = math.floor ((xbb.BubbleXPCurrent_pve / xbb.BubbleXP_pve) * 100)
		xbb.PlayerLevel_pve = "LVL" .. xbb.PlayerLevel_pve
	end
end

-----------------------------------------------------------------------

function xbb:UpdateDataPvp()
	--rvr
	xbb.PlayerTotalXP_pvp = GetUnitAvARankPoints("player")
	xbb.PlayerLevel_pvp = GetUnitAvARank("player") + 1
	local xbb_xpcurrentrank = GetNumPointsNeededForAvARank(xbb.PlayerLevel_pvp - 1)
	xbb.PlayerXP_pvp = xbb.PlayerTotalXP_pvp - xbb_xpcurrentrank
	xbb.PlayerXPtoLevel_pvp = GetNumPointsNeededForAvARank(xbb.PlayerLevel_pvp) - xbb_xpcurrentrank
	xbb.numberOfFull_pvp = math.floor ((xbb.PlayerXP_pvp / xbb.PlayerXPtoLevel_pvp) * 10)
	xbb.BubbleXP_pvp = xbb.PlayerXPtoLevel_pvp / 10
	xbb.BubbleXPCurrent_pvp = xbb.PlayerXP_pvp - (xbb.BubbleXP_pvp * xbb.numberOfFull_pvp)
	xbb.XpBarPercent_pvp = math.floor ((xbb.BubbleXPCurrent_pvp / xbb.BubbleXP_pvp) * 100)
end

-----------------------------------------------------------------------

function xbb:MenuInitialize()
	ZO_OptionsWindow_AddUserPanel("XBB_OPTION_WINDOW", "Xp Bar Bubble");
	ZO_PreHook("ZO_OptionsWindow_ChangePanels", function(p)
			if (p == _G["XBB_OPTION_WINDOW"]) then 
				ZO_OptionsWindowResetToDefaultButton:SetEnabled(false)
				ZO_OptionsWindowResetToDefaultButton:SetKeybindEnabled(false)
			end
		end)
	-- Header -------------
	
	xbb.OW_Header = wm:CreateControlFromVirtual("XBB_OPTION_HEADER", ZO_OptionsWindowSettingsScrollChild, "ZO_Options_SectionTitle")
	xbb.OW_Header:SetAnchor(TOPLEFT)
	xbb.OW_Header.controlType = OPTIONS_SECTION_TITLE
	xbb.OW_Header.panel = _G["XBB_OPTION_WINDOW"]
	xbb.OW_Header.text = "OPTIONS"
	
	ZO_OptionsWindow_InitializeControl(xbb.OW_Header)
	
	-- Flat Checkbox -------------
	
	xbb.OW_FlatCheckbox = wm:CreateControlFromVirtual("XBB_FLAT_CHECKBOX", ZO_OptionsWindowSettingsScrollChild, "ZO_Options_Checkbox")
	xbb.OW_FlatCheckbox:SetAnchor(TOPLEFT, xbb.OW_Header, BOTTOMLEFT, 0, 6)
	xbb.OW_FlatCheckbox.controlType = OPTIONS_CHECKBOX
	xbb.OW_FlatCheckbox.system = SETTING_TYPE_UI
	xbb.OW_FlatCheckbox.settingId = _G[string.format("SETTING_XBB_FLAT_CHECKBOX")]
	xbb.OW_FlatCheckbox.panel = _G["XBB_OPTION_WINDOW"]
	xbb.OW_FlatCheckbox.text = "Flat Layout"
	xbb.OW_FlatCheckbox.tooltipText = "Normal or Flat"
	
	xbb.OW_FlatCheckbox.Button = xbb.OW_FlatCheckbox:GetNamedChild("Checkbox")
	
	ZO_PreHookHandler(xbb.OW_FlatCheckbox, "OnShow", function()
		xbb.OW_FlatCheckbox.Button:SetState(self:GetFlat() and 1 or 0)
		xbb.OW_FlatCheckbox.Button:toggleFunction(self:GetFlat())
		end)
	ZO_PreHookHandler(xbb.OW_FlatCheckbox.Button, "OnClicked", function() self:SetFlat() end)
	
	xbb.OW_FlatCheckbox.Warning = wm:CreateControlFromVirtual("XBB_FLAT_CHECKBOX_WARNING", xbb.OW_FlatCheckbox, "ZO_Options_WarningIcon")
	xbb.OW_FlatCheckbox.Warning:SetAnchor(RIGHT, xbb.OW_FlatCheckbox.Button, LEFT, -5, 0)
	xbb.OW_FlatCheckbox.Warning.tooltipText = "You need to reload the UI after changing this option"
	
	ZO_OptionsWindow_InitializeControl(xbb.OW_FlatCheckbox)
	
	-- Skin Dropdown-------------
	
	xbb.OW_SkinDropdown = wm:CreateControlFromVirtual("XBB_SKIN_DROPDOWN", ZO_OptionsWindowSettingsScrollChild, "ZO_Options_Dropdown")
	xbb.OW_SkinDropdown:SetAnchor(TOPLEFT, xbb.OW_FlatCheckbox, BOTTOMLEFT, 0, 6)
	xbb.OW_SkinDropdown.controlType = OPTIONS_DROPDOWN
	xbb.OW_SkinDropdown.system = SETTING_TYPE_UI
	xbb.OW_SkinDropdown.panel = _G["XBB_OPTION_WINDOW"]
	xbb.OW_SkinDropdown.text = "Skins"
	xbb.OW_SkinDropdown.tooltipText = "Select one skin"
	xbb.OW_SkinDropdown.valid = {
									"ZO_DefaultBackdrop",
									"ZO_ThinBackdrop",
									"ZO_InsetBackdrop",
									"ZO_InsetTexture",
									"ZO_CenterlessBackdrop"
								}
	xbb.OW_SkinDropdown.Dropmenu = ZO_ComboBox_ObjectFromContainer(GetControl(xbb.OW_SkinDropdown, "Dropdown"))
	local setText = xbb.OW_SkinDropdown.Dropmenu.m_selectedItemText.SetText
	
	ZO_PreHookHandler(xbb.OW_SkinDropdown.Dropmenu.m_selectedItemText, "OnTextChanged", function(self)
			if xbb.OW_SkinDropdown.Dropmenu.m_selectedItemData then
				local select = xbb.OW_SkinDropdown.Dropmenu.m_selectedItemData.name
				setText(self, select)
				xbb:SetSkin(select)
			end
		end)
	xbb.OW_SkinDropdown:SetHandler("OnShow", function() xbb.OW_SkinDropdown.Dropmenu:SetSelectedItem( self:GetSkin()) end)
	
	xbb.OW_SkinDropdown.Warning = wm:CreateControlFromVirtual("XBB_SKIN_DROPDOWN_WARNING", xbb.OW_SkinDropdown, "ZO_Options_WarningIcon")
	xbb.OW_SkinDropdown.Warning:SetAnchor(RIGHT, xbb.OW_SkinDropdown:GetNamedChild("Dropdown"), LEFT, -5, 0)
	xbb.OW_SkinDropdown.Warning.tooltipText = "You need to reload the UI after changing this option"
	
	ZO_OptionsWindow_InitializeControl(xbb.OW_SkinDropdown)
	
	-- Scale EditBox-------------
	
	xbb.OW_ScaleEditBox = wm:CreateTopLevelWindow("XBB_SCALE_EDITBOX")
	xbb.OW_ScaleEditBox:SetParent(ZO_OptionsWindowSettingsScrollChild)
	xbb.OW_ScaleEditBox:SetAnchor(TOPLEFT, xbb.OW_SkinDropdown, BOTTOMLEFT, 0, 10)
	xbb.OW_ScaleEditBox:SetResizeToFitDescendents(true)
	xbb.OW_ScaleEditBox:SetWidth(510)
	xbb.OW_ScaleEditBox:SetMouseEnabled(true)
	
	xbb.OW_ScaleEditBox.Label = wm:CreateControl("XBB_SCALE_EDITBOX_LABEL", xbb.OW_ScaleEditBox, CT_LABEL)
	xbb.OW_ScaleEditBox.Label:SetDimensions(300, 26)
	xbb.OW_ScaleEditBox.Label:SetAnchor(TOPLEFT)
	xbb.OW_ScaleEditBox.Label:SetFont("ZoFontWinH4")
	xbb.OW_ScaleEditBox.Label:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)
	xbb.OW_ScaleEditBox.Label:SetText("Scale")
	
	xbb.OW_ScaleEditBox.Bg = wm:CreateControlFromVirtual("XBB_SCALE_EDITBOX_BG", xbb.OW_ScaleEditBox, "ZO_EditBackdrop")
	xbb.OW_ScaleEditBox.Bg:SetDimensions(200, 24)
	xbb.OW_ScaleEditBox.Bg:SetAnchor(RIGHT)
	
	xbb.OW_ScaleEditBox.Edit = wm:CreateControlFromVirtual("XBB_SCALE_EDITBOX_EDIT", xbb.OW_ScaleEditBox.Bg, "ZO_DefaultEditForBackdrop")
	xbb.OW_ScaleEditBox.Edit:SetText(self:GetScale())
	xbb.OW_ScaleEditBox.Edit:SetHandler("OnFocusLost", function(self) xbb:SetScale(tonumber(self:GetText())) end)
	
	
	xbb.OW_ScaleEditBox.panel = _G["XBB_OPTION_WINDOW"]
	xbb.OW_ScaleEditBox.tooltipText = "A normal scale is around 0.8"
	xbb.OW_ScaleEditBox:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
	xbb.OW_ScaleEditBox:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)

	ZO_OptionsWindow_InitializeControl(xbb.OW_ScaleEditBox)
	
	-- Alpha EditBox-------------
	
	xbb.OW_AlphaEditBox = wm:CreateTopLevelWindow("XBB_ALPHA_EDITBOX")
	xbb.OW_AlphaEditBox:SetParent(ZO_OptionsWindowSettingsScrollChild)
	xbb.OW_AlphaEditBox:SetAnchor(TOPLEFT, xbb.OW_ScaleEditBox, BOTTOMLEFT, 0, 10)
	xbb.OW_AlphaEditBox:SetResizeToFitDescendents(true)
	xbb.OW_AlphaEditBox:SetWidth(510)
	xbb.OW_AlphaEditBox:SetMouseEnabled(true)
	
	xbb.OW_AlphaEditBox.Label = wm:CreateControl("XBB_ALPHA_EDITBOX_LABEL", xbb.OW_AlphaEditBox, CT_LABEL)
	xbb.OW_AlphaEditBox.Label:SetDimensions(300, 26)
	xbb.OW_AlphaEditBox.Label:SetAnchor(TOPLEFT)
	xbb.OW_AlphaEditBox.Label:SetFont("ZoFontWinH4")
	xbb.OW_AlphaEditBox.Label:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)
	xbb.OW_AlphaEditBox.Label:SetText("Transparency")
	
	xbb.OW_AlphaEditBox.Bg = wm:CreateControlFromVirtual("XBB_ALPHA_EDITBOX_BG", xbb.OW_AlphaEditBox, "ZO_EditBackdrop")
	xbb.OW_AlphaEditBox.Bg:SetDimensions(200, 24)
	xbb.OW_AlphaEditBox.Bg:SetAnchor(RIGHT)
	
	xbb.OW_AlphaEditBox.Edit = wm:CreateControlFromVirtual("XBB_ALPHA_EDITBOX_EDIT", xbb.OW_AlphaEditBox.Bg, "ZO_DefaultEditForBackdrop")
	xbb.OW_AlphaEditBox.Edit:SetText(self:GetAlpha())
	xbb.OW_AlphaEditBox.Edit:SetHandler("OnFocusLost", function(self) xbb:SetAlpha(tonumber(self:GetText())) end)
	
	
	xbb.OW_AlphaEditBox.panel = _G["XBB_OPTION_WINDOW"]
	xbb.OW_AlphaEditBox.tooltipText = "No transparency is 1, full is 0"
	xbb.OW_AlphaEditBox:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
	xbb.OW_AlphaEditBox:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)

	ZO_OptionsWindow_InitializeControl(xbb.OW_AlphaEditBox)
	
	-- Position Button-------------

	xbb.OW_Position= wm:CreateTopLevelWindow("XBB_POSITION")
	xbb.OW_Position:SetParent(ZO_OptionsWindowSettingsScrollChild)
	xbb.OW_Position:SetAnchor(TOPLEFT, xbb.OW_AlphaEditBox, BOTTOMLEFT, 0, 6)
	xbb.OW_Position:SetDimensions(510, 28)
	xbb.OW_Position:SetMouseEnabled(true)
	
	xbb.OW_Position.Label = wm:CreateControl("XBB_POSITION_BUTTON_LABEL", xbb.OW_Position, CT_LABEL)
	xbb.OW_Position.Label:SetDimensions(300, 26)
	xbb.OW_Position.Label:SetAnchor(TOPLEFT)
	xbb.OW_Position.Label:SetFont("ZoFontWinH4")
	xbb.OW_Position.Label:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)
	xbb.OW_Position.Label:SetText("Position")
	
	xbb.OW_Position.Button = wm:CreateControlFromVirtual("XBB_POSITION_BUTTON", xbb.OW_Position, "ZO_DefaultButton")
	xbb.OW_Position.Button:SetAnchor(TOPRIGHT)
	xbb.OW_Position.Button:SetWidth(200)
	xbb.OW_Position.Button:SetText("UNLOCK")
	xbb.OW_Position.Button:SetHandler("OnClicked", function() self:MoveOnClick() end)
	
	xbb.OW_Position.controlType = OPTIONS_CUSTOM
	xbb.OW_Position.customSetupFunction = function()  end	
	xbb.OW_Position.panel = _G["XBB_OPTION_WINDOW"]
	xbb.OW_Position.Button.tooltipText = "Press the buton to unlock the add-on and and drag and drop it where you want. The position will be save after a lock"
	xbb.OW_Position.Button:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
	xbb.OW_Position.Button:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
	
	xbb.OW_Position.Unlock = true
		
	ZO_OptionsWindow_InitializeControl(xbb.OW_Position)
	
end

-----------------------------------------------------------------------

function xbb:Initialize()
	
	xbb:UpdateDataPve()
	xbb:UpdateDataPvp()
	
	if (xbb.saved.mw_flat == true) then
		xbb.flat_x = 265
		xbb.flat_y = 0
		xbb.bar_offset_y_pve = -5
		xbb.bar_offset_x_pve = 5
		xbb.bar_offset_y_pvp = -5
		xbb.bar_offset_x_pvp = 7
	else
		xbb.flat_x = 0
		xbb.flat_y = 55
		xbb.bar_offset_y_pvp = -10
	end
	
	xbb.MW = wm:CreateTopLevelWindow(xbb.AddOnName .. "_MW")
	xbb.MW:SetDimensions(265 + xbb.flat_x, 55 + xbb.flat_y)
	xbb.MW:SetAnchor(CENTER, GuiRoot, TOPLEFT, xbb.saved.mw_x, xbb.saved.mw_y)
	xbb.MW:SetHidden(false)
	xbb.MW:SetClampedToScreen(true)
	xbb.MW:SetScale(xbb.saved.mw_scale)
	xbb.MW:SetHandler("OnMouseDown", function() xbb.MW:SetAlpha(0.4) end)
	xbb.MW:SetHandler("OnMouseUp", function() xbb.MW:SetAlpha(xbb.saved.mw_alpha) end)
	--xbb.MW:SetHandler("OnReceiveDrag", function(self) self:StartMoving() end)
	xbb.MW.backdrop = wm:CreateControlFromVirtual(xbb.AddOnName .. "MW_backdrop", xbb.MW, xbb.saved.mw_skin)
	xbb.MW.backdrop:SetAnchorFill(xbb.MW)
	xbb.MW:SetAlpha(xbb.saved.mw_alpha)
	xbb.MW:SetDrawLayer(0)
	--XP PvE level
	
	xbb.MW.XpBarPve = wm:CreateControl(xbb.AddOnName .. "MW_XpBarPve", xbb.MW, CT_BACKDROP)
	xbb.MW.XpBarPve:SetCenterColor(0.31,0.35,0.75,1)
	xbb.MW.XpBarPve:SetEdgeTexture("",1,1,1)
	xbb.MW.XpBarPve:SetDrawLayer(1)
	xbb.MW.XpBarPve:SetDimensions(xbb.XpBarPercent_pve * 2, 6)
	xbb.MW.XpBarPve:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 9 + xbb.bar_offset_x_pve , 43 + xbb.bar_offset_y_pve)
	xbb.MW.XpBarPve:SetHidden(false)
	
	xbb.MW.XpBarPveBg = wm:CreateControl(xbb.AddOnName .."MW_XpBarPveBg", xbb.MW, CT_BACKDROP)
	xbb.MW.XpBarPveBg:SetCenterColor(0.8,0.8,1,1)
	xbb.MW.XpBarPveBg:SetEdgeTexture("",1,1,0)
	xbb.MW.XpBarPveBg:SetDrawLayer(0)
	xbb.MW.XpBarPveBg:SetDimensions(200, 6)
	xbb.MW.XpBarPveBg:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 10 +  xbb.bar_offset_x_pve , 43 + xbb.bar_offset_y_pve)
	xbb.MW.XpBarPveBg:SetHidden(false)
	
	xbb.MW.XpBarPveLbl = wm:CreateControl(xbb.AddOnName .. "MW_XpBarPveLbl", xbb.MW, CT_LABEL)
	xbb.MW.XpBarPveLbl:SetFont("ZoFontAnnounceMessage")
	xbb.MW.XpBarPveLbl:SetDrawLayer(0)
	xbb.MW.XpBarPveLbl:SetDimensions(60, 30)
	xbb.MW.XpBarPveLbl:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 217 + xbb.bar_offset_x_pve, 30 + xbb.bar_offset_y_pve)
	xbb.MW.XpBarPveLbl:SetScale(0.60)
	xbb.MW.XpBarPveLbl:SetText(xbb.PlayerLevel_pve)
	xbb.MW.XpBarPveLbl:SetHidden(false)
	
	xbb.MW.XpBubblePve = {}
	

	for i = 1, xbb.numberOfFull_pve do
	
		xbb.MW.XpBubblePve[i] = wm:CreateControl(xbb.AddOnName .. "MW_XpBubblePve" .. i, xbb.MW, CT_TEXTURE)
		xbb.MW.XpBubblePve[i]:SetTexture(xbb.FullBubblePve)
		xbb.MW.XpBubblePve[i]:SetDimensions(15, 15)
		xbb.MW.XpBubblePve[i]:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 9 + (20 * (i - 1)) + xbb.bar_offset_x_pve , 18 + xbb.bar_offset_y_pve)
	end
	
	for i = (xbb.numberOfFull_pve + 1), 10  do
	
		xbb.MW.XpBubblePve[i] = wm:CreateControl(xbb.AddOnName .. "MW_XpBubblePve" .. i, xbb.MW, CT_TEXTURE)
		xbb.MW.XpBubblePve[i]:SetTexture(xbb.EmptyBubblePve)
		xbb.MW.XpBubblePve[i]:SetDimensions(15, 15)
		xbb.MW.XpBubblePve[i]:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 9 + (20 * (i - 1)) + xbb.bar_offset_x_pve , 18 + xbb.bar_offset_y_pve)
	end
	
	--Xp RvR level
	
	xbb.MW.XpBarPvp = wm:CreateControl(xbb.AddOnName .. "MW_XpBarPvp", xbb.MW, CT_BACKDROP)
	xbb.MW.XpBarPvp:SetCenterColor(0.8,0.15,0.3,1)
	xbb.MW.XpBarPvp:SetEdgeTexture("",1,1,1)
	xbb.MW.XpBarPvp:SetDrawLayer(1)
	xbb.MW.XpBarPvp:SetDimensions(xbb.XpBarPercent_pvp * 2, 6)
	xbb.MW.XpBarPvp:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 9 + xbb.bar_offset_x_pvp + xbb.flat_x, 43 + xbb.bar_offset_y_pvp + xbb.flat_y)
	xbb.MW.XpBarPvp:SetHidden(false)
	
	xbb.MW.XpBarPvpBg = wm:CreateControl(xbb.AddOnName .. "MW_XpBarPvpBg", xbb.MW, CT_BACKDROP)
	xbb.MW.XpBarPvpBg:SetCenterColor(0.8,0.8,1,1)
	xbb.MW.XpBarPvpBg:SetEdgeTexture("",1,1,0)
	xbb.MW.XpBarPvpBg:SetDrawLayer(0)
	xbb.MW.XpBarPvpBg:SetDimensions(200, 6)
	xbb.MW.XpBarPvpBg:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 10 +  xbb.bar_offset_x_pvp + xbb.flat_x, 43 + xbb.bar_offset_y_pvp + xbb.flat_y)
	xbb.MW.XpBarPvpBg:SetHidden(false)
	
	xbb.MW.XpBarPvpLbl = wm:CreateControl(xbb.AddOnName .. "MW_XpBarPvpLbl", xbb.MW, CT_LABEL)
	xbb.MW.XpBarPvpLbl:SetFont("ZoFontAnnounceMessage")
	xbb.MW.XpBarPvpLbl:SetDrawLayer(1)
	xbb.MW.XpBarPvpLbl:SetDimensions(60, 30)
	xbb.MW.XpBarPvpLbl:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 217 + xbb.bar_offset_x_pvp + xbb.flat_x, 30 + xbb.bar_offset_y_pvp + xbb.flat_y)
	xbb.MW.XpBarPvpLbl:SetScale(0.60)
	xbb.MW.XpBarPvpLbl:SetText("RR" .. xbb.PlayerLevel_pvp)
	xbb.MW.XpBarPvpLbl:SetHidden(false)
	
	xbb.MW.XpBubblePvp = {}
	for i = 1, xbb.numberOfFull_pvp do
	
		xbb.MW.XpBubblePvp[i] = wm:CreateControl(xbb.AddOnName .. "MW_XpBubblePvp" .. i, xbb.MW, CT_TEXTURE)
		xbb.MW.XpBubblePvp[i]:SetTexture(xbb.FullBubblePvp)
		xbb.MW.XpBubblePvp[i]:SetDimensions(16, 16)
		xbb.MW.XpBubblePvp[i]:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 9 + (20 * (i - 1)) + xbb.bar_offset_x_pvp + xbb.flat_x, 18 + xbb.bar_offset_y_pvp + xbb.flat_y)
	end
	
	
	for i = (xbb.numberOfFull_pvp + 1), 10  do
	
		xbb.MW.XpBubblePvp[i] = wm:CreateControl(xbb.AddOnName .. "MW_XpBubblePvp" .. i, xbb.MW, CT_TEXTURE)
		xbb.MW.XpBubblePvp[i]:SetTexture(xbb.EmptyBubblePvp)
		xbb.MW.XpBubblePvp[i]:SetDimensions(15, 15)
		xbb.MW.XpBubblePvp[i]:SetAnchor(TOPLEFT, xbb.MW, TOPLEFT, 9 + (20 * (i - 1)) + xbb.bar_offset_x_pvp + xbb.flat_x, 18 + xbb.bar_offset_y_pvp + xbb.flat_y)
	end
					
end

-----------------------------------------------------------------------

function xbb:UpdatePve ()
	xbb:UpdateDataPve()
 
	if ((xbb.MW ~= nil)) then
		xbb.MW.XpBarPve:SetDimensions(xbb.XpBarPercent_pve * 2, 5)
		xbb.MW.XpBarPveLbl:SetText(xbb.PlayerLevel_pve)
				
		for i = 1, xbb.numberOfFull_pve do
			xbb.MW.XpBubblePve[i]:SetTexture(xbb.FullBubblePve)
		end
			
		for i = (xbb.numberOfFull_pve + 1), 10  do
			xbb.MW.XpBubblePve[i]:SetTexture(xbb.EmptyBubblePve)
		end
	end
end

-----------------------------------------------------------------------

function xbb:UpdatePvp ()
	xbb:UpdateDataPvp()

	if ((xbb.MW ~= nil) and (xbb.MW.XpBarPvp ~= nil)) then
		xbb.MW.XpBarPvp:SetDimensions(xbb.XpBarPercent_pvp * 2, 5)
		xbb.MW.XpBarPvpLbl:SetText("RR" .. xbb.PlayerLevel_pvp)
			
		for i = 1, xbb.numberOfFull_pvp do
			xbb.MW.XpBubblePvp[i]:SetTexture(xbb.FullBubblePvp)
		end
		
		for i = (xbb.numberOfFull_pvp + 1), 10  do
			xbb.MW.XpBubblePvp[i]:SetTexture(xbb.EmptyBubblePvp)
		end
	end		
end

-----------------------------------------------------------------------

function xbb:MenuOpened()
		local checkReticle = IsReticleHidden()
		if (checkReticle == false) then
			xbb.MW:SetAlpha(xbb.saved.mw_alpha)
		else
			xbb.MW:SetAlpha(0.2)		
		end
end

-----------------------------------------------------------------------

function xbb:OnAddOnLoaded(eventCode, addOnName)
	if(addOnName == xbb.AddOnName) then	
		Defaults = 
		{
			["mw_x"] = 0,
			["mw_y"] = -300,
			["mw_scale"] = 0.80,
			["mw_flat"] = false,
			["mw_skin"] = "ZO_DefaultBackdrop",
			["mw_alpha"] = 0.9
		}
		if (xbb.saved == nil) then
			xbb.saved = ZO_SavedVars:New("XpBarBubbleSave", 1, nil, Defaults, nil)
		end
		xbb:MenuInitialize()
		xbb:Initialize()
	end
end

-----------------------------------------------------------------------

function xbb:SetScale(scale)
	xbb.saved.mw_scale = scale
	xbb.MW:SetScale(xbb.saved.mw_scale)
end

-----------------------------------------------------------------------

function xbb:GetScale()
	return xbb.saved.mw_scale
end

-----------------------------------------------------------------------

function xbb:SetAlpha(alpha)
	xbb.saved.mw_alpha = alpha
	xbb.MW:SetAlpha(xbb.saved.mw_alpha)
end

-----------------------------------------------------------------------

function xbb:GetAlpha()
	return xbb.saved.mw_alpha
end


-----------------------------------------------------------------------

function xbb:SetSkin(skin)
	xbb.saved.mw_skin = skin
end

-----------------------------------------------------------------------

function xbb:GetSkin()
	return xbb.saved.mw_skin
end

-----------------------------------------------------------------------

function xbb:SetFlat()
	xbb.saved.mw_flat = not xbb.saved.mw_flat
end

-----------------------------------------------------------------------

function xbb:GetFlat()
	return xbb.saved.mw_flat
end

-----------------------------------------------------------------------

function xbb:MoveOnClick()
	if (xbb.MW ~= nil) then
		if (xbb.OW_Position.Unlock == true) then
			xbb.MW:SetMovable(true)
			xbb.MW:SetMouseEnabled(true)
			xbb.OW_Position.Button:SetText("LOCK")
			xbb.OW_Position.Unlock = false
		else
			xbb.MW:SetMovable(false)
			xbb.MW:SetMouseEnabled(false)
			xbb.OW_Position.Button:SetText("UNLOCK")
			xbb.OW_Position.Unlock = true
			var_x, var_y = xbb.MW:GetCenter()
			xbb.saved.mw_x = math.floor (var_x)
			xbb.saved.mw_y = math.floor (var_y)	
		end
	end
end
	
-----------------------------------------------------------------------

xbb:New()